{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<script type="text/javascript">
    {% endblock begin_javascript_fix %}



    {% block begin_javascript %}
    {{ parent() }}
    {{ modulename }}Obj.prototype = {
        storeConfig:{
            clientG:{routeName:'BaseController-getComboValues',table:'clients'}
            ,clientSource:{routeName:'BaseController-getComboValues',table:'clients'}
            ,losttype:{routeName:'LostType-getComboValues',table:'lost_types',limit:250}
            ,losttypeG:{routeName:'LostType-getComboValues',table:'lost_types',limit:250}
        },
        getSelectedRecordsourcelost: function() {
            return (this.grids && this.grids.searchsourcelost && this.grids.searchsourcelost.selectedRow) ? this.grids.searchsourcelost.selectedRow.data : false;
        },
        editSelectedRecordSourceLost:function(){
            var selectedRecord = this.getSelectedRecordsourcelost();
            if (selectedRecord !== false){
                this.forms.main.setValue({sourcelosttype:selectedRecord.losttype});
                this.winsourcelost.hide();
            }
        },
        _onButtonSearchSourceLostClick: function() {
            var t = this;
            var fv=t.forms.main.getValue();
            var sc=fv.sourceclient;
            var start=fv.start;
            if(sc==null){
                return;
            }
            var _itemStore=t.storeConfig.MouldGroup;
            var _routeName = 'SourceLostTypeChangeDone-searchsourcelost';
            var _route = Routing.getRoute(_routeName);
            var _data = {
                'pg': 1,
                'lm': t.recordsperpage,
                'client':sc,
                'start':start
            };
            var _url = Routing.generate(_routeName, _data);
            if(!t.winsourcelost){
                t.stores.searchsourcelost=new mj.store({
                    url: _url,
                    method: _route.requirements._method,
                    modulename:t.modulename,
                    routename:_routeName,
                    routedata:_data
                });
                t.winsourcelost = new mj.window({
                    renderTo : mj.NE(),
                    title : '',
                    modal : true,
                    width : 600,
                    height : 400,
                    minWidth : 600,
                    minHeight : 400,
                    buttons : [
                        {title: mj.lng.glb.exit, handler:function(){
                            t.winsourcelost.hide();
                        }}
                    ]
                });
                
                t.win.addRelated(t.winsourcelost);

                t.grids.searchsourcelost = new mj.grid({
                    win: t.winsourcelost,
                    renderTo: t.winsourcelost.getBody(),
                    store: t.stores.searchsourcelost,
                    pbar: new mj.pager({defaultButtons:false,elements: {selectLimit:false}, limit:null}),
                    fitToParent: true,
                    cm : [
                        {header: mj.lng.glb.id, dataIndex: 'id', width:5, align:'right',hide:true},
                        {header: "", dataIndex: 'client', width: 5,hide:true},
                        {header: "{{ 'SourceLostTypeChangeDone.losttype'|trans }}", dataIndex: 'losttype', width: 250},
                        {header: "{{ 'SourceLostTypeChangeDone.start'|trans }}", dataIndex: 'start', width: 120},
                        {header: "{{ 'SourceLostTypeChangeDone.finish'|trans }}", dataIndex: 'finish',  width: 120},
                        {header: '', width: 5,hide:true}
                    ]
                });
                t.grids.searchsourcelost.on('rowdblclick', t.editSelectedRecordSourceLost, t);
            }
            t.stores.searchsourcelost.url=_url;
            t.stores.searchsourcelost.routedata=_data;
            t.winsourcelost.show();
            t.grids.searchsourcelost.load();
        },
        init : function(){
            var t = this;
            {{ modulename }}Obj.superclass.init.call(t);
            t.winsourcelost=false;
            t.windowButtons.add=false;
            t.windowButtons.delete=false;
            const gridConfig = {
                cm: [
                    {header: "{{ 'SourceLostTypeChangeDone.client'|trans }}", dataIndex: 'client', width: 80,filter:'single',alias:'cld',type:'combo',store:t.stores.clientG,operator:'='},
                    {header: "{{ 'SourceLostTypeChangeDone.losttype'|trans }}", dataIndex: 'losttype_old', width: 170,filter:'single',alias:'cld',type:'combo',store:t.stores.losttypeG,operator:'=',fieldname:'losttype'},
                    {header: "{{ 'SourceLostTypeChangeDone.start'|trans }}", dataIndex: 'start', width: 120,filter:'single',alias:'cld',operator:'='},
                    {header: "{{ 'SourceLostTypeChangeDone.finish'|trans }}", dataIndex: 'finish', width: 120,filter:'single',alias:'cld',operator:'='},
                    {header: "{{ 'SourceLostTypeChangeDone.sourceclient'|trans }}", dataIndex: 'sourceclient', width: 100},
                    {header: "{{ 'SourceLostTypeChangeDone.losttype'|trans }}", dataIndex: 'sourcelosttype', width: 170},
                    {header: "{{ 'SourceLostTypeChangeDone.taskfinishtype'|trans }}", dataIndex: 'taskfinishtype', width: 170}
                ]
            };

            t._setGridConfig(gridConfig);

            const formConfig= {
                items: [
                    new mj.form.field({
                        dataIndex: 'id',
                        hidden: true
                    }),
                    new mj.form.field({
                        dataIndex: 'version',
                        hidden: true
                    }),
                    new mj.form.textField({
                        title: "{{ 'SourceLostTypeChangeDone.client'|trans }}",
                        dataIndex: 'client',
                        maxLength: 50,
                        labelWidth : '120px',
                        width:200,
                        grid: 's4 m2',
                        disabled:true
                    }),
                    new mj.form.textField({
                        title: "{{ 'SourceLostTypeChangeDone.losttype'|trans }}",
                        dataIndex: 'losttype_old',
                        maxLength: 50,
                        labelWidth : '120px',
                        width:200,
                        grid: 's4 m2',
                        disabled:true
                    }),
                    new mj.form.textField({
                        title: "{{ 'SourceLostTypeChangeDone.start'|trans }}",
                        dataIndex: 'start',
                        labelWidth : '120px',
                        notEmpty: true,
                        grid: 's4 m2',
                        disabled:true
                    }),
                    new mj.form.textField({
                        title: "{{ 'SourceLostTypeChangeDone.finish'|trans }}",
                        dataIndex: 'finish',
                        labelWidth : '120px',
                        grid: 's4 m2',
                        disabled:true
                    }),
                    //new mj.form.textField({
                    //    title: "{{ 'SourceLostTypeChangeDone.sourceclient'|trans }}",
                    //    dataIndex: 'sourceclient',
                    //    maxLength: 50,
                    //    labelWidth : '120px',
                    //    width:200,
                    //    grid: 's4 m2',
                    //    disabled:true
                    //}),
                    new mj.form.textField({
                        title: "{{ 'SourceLostTypeChangeDone.taskfinishtype'|trans }}",
                        dataIndex: 'taskfinishtype',
                        maxLength: 50,
                        labelWidth : '120px',
                        width:200,
                        grid: 's4 m2',
                        disabled:true
                    }),
                    new mj.form.combo({
                        title: "{{ 'SourceLostTypeChangeDone.sourceclient'|trans }}",
                        placeHolder: "{{ 'SourceLostTypeChangeDone.sourceclient'|trans }}",
                        dataIndex: 'sourceclient',
                        mode: 'remote',
                        clearOnTriggerClick: true,
                        labelWidth : '120px',
                        grid: 's6 m4',
                        width:200,
                        store: t.stores.clientSource
                    }),
                    
                    new mj.form.combo({
                        title: "{{ 'SourceLostTypeChangeDone.losttype'|trans }}",
                        placeHolder: "{{ 'SourceLostTypeChangeDone.losttype_new_placeholder'|trans }}",
                        dataIndex: 'sourcelosttype',
                        mode: 'remote',
                        clearOnTriggerClick: true,
                        labelWidth : '120px',
                        grid: 's6 m4',
                        width:200,
                        store: t.stores.losttype
                    }),
                    new mj.form.textArea({
                        title : "{{ 'SourceLostTypeChangeDone.sourcedescriptionlost'|trans }}",
                        dataIndex : 'sourcedescriptionlost',
                        labelWidth : '120px',
                        width:300,
                        height:80,
                        maxLength: 255
                    })
                ]
            };
            t._setFormConfig(formConfig);

            t.buttons.searchsourcelost = t.forms.main.addButton({
                alt: "{{ 'SourceLostTypeChangeDone.searchsourcelost'|trans }}",
                cls: 'btn-sm left',
                iconCls: 'mj-zoom',
                scope: t,
                handler: t._onButtonSearchSourceLostClick
			});
            t.win.on('close',function(){
                if(t.winsourcelost){
                    t.grids.searchsourcelost.destroy();
                    t.winsourcelost.destroy();
                }
            });
        }
        
    };
    {% endblock begin_javascript %}



    {% block begin_default_module %}
    {{ parent() }}
    {% endblock begin_default_module %}



    {% block end_default_module %}
    {{ parent() }}
    {% endblock end_default_module %}


    {% block end_javascript %}
    {{ parent() }}
    {% endblock end_javascript %}


    {% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
    {{ parent() }}
{% endblock body %}
